# less_equal

### Synopsis

    template<
          typename T1
        , typename T2
        >
    struct less_equal
    {
        typedef unspecified type;
    };

### Description

Returns `true_` if `T1::value <= T2::value` and `false_` otherwise [1].

### Definition

    #include "boost/mpl/less_equal.hpp"

### Parameters

Parameter | Requirement | Description
--- | --- | ---
`T1, T2` | A model of Integral Constant |

### Expression semantics

Expression | Expression type | Precondition | Semantics | Postcondition
--- | --- | --- | --- | ---
`typedef less_equal<t1,t2>::type c;` | A model of `bool` Integral Constant |  | Equivalent to `typedef bool_<(t1::value <= t2::value)> c;` |

### Complexity

Amortized constant time.

### Example

    typedef list_c<int,0,1,2,3,4,5,6,7,8,9> numbers;
    typedef remove_if< numbers, less_equal<_1,int_<4> > >::type result;
    BOOST_STATIC_ASSERT(equal< result,range_c<int,5,10> >::type::value));

### Notes

[1] The `less_equal` metafunction can be (and is expected to be) specialized by user to work on user-defined types that do not satisfy the Integral Constant requirements. The requirements listed here are the ones imposed by the default implementation.

### See also

Metafunctions, `less`, `greater`, `greater_equal`, `equal`, `not_equal_to`

Table of Contents
Last edited March 10, 2003 6:28 am